---
title: v1.2.0
weight: 998998000
---

## (Golang based operators) Update Makefile's bundle target

In the `Makefile` file, replace `bundle: manifests` with `bundle: manifests kustomize` to call the kustomize target when the `bundle` target is used.

_See [#4090](https://github.com/operator-framework/operator-sdk/pull/4090) for more details._

## (Golang based operators)  Upgrade sigs.k8s.io/controller-runtime version to v0.6.3

In the `go.mod` file replace `sigs.k8s.io/controller-runtime v0.6.2` with `sigs.k8s.io/controller-runtime v0.6.3` and then run `go mod tidy`.

_See [#4062](https://github.com/operator-framework/operator-sdk/pull/4062) for more details._

## (Golang based operators with multigroup support) Fix `CRDDirectoryPath` in `controllers/<group>/suite_test.go`

If your project is multi-group, then replace `CRDDirectoryPaths: []string{filepath.Join("..", "config", "crd", "bases")},` with `CRDDirectoryPaths: []string{filepath.Join("..", "..", "config", "crd", "bases")},` in `suite_test.go` files found in `controllers/<group>/` directories. Otherwise, the tests will fail since this EnvTest will not be looking for the CRD's in the correct location. For more info, see [kubebuilder#1665](https://github.com/kubernetes-sigs/kubebuilder/issues/1665).

_See [#4062](https://github.com/operator-framework/operator-sdk/pull/4062) for more details._
